#ifndef NOMDELOGICIEL_SEEN
#define NOMDELOGICIEL_SEEN

#include "trivaluedBool.h"
#include "nomdElements.h"

#include <string> 
#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;

class nomDeLogiciel
{

 public : 
  
  enum Logiciel
  {
    parmela, transport, generator, test, madx, usersprogram, unknownSoftware
  };
  
    
 private :

  Logiciel program_;
  std::string progString_;

  /**
     Accepted elements list for this software
  */
  std::vector <nomdElements::typedElement> acceptedElements_;

  /**
     Ignore software list for this element
  */
  std::vector <nomdElements::typedElement> ignoredElements_;

   
  static Logiciel fromString( std::string s);
  static std::string toString( Logiciel lg);  
  std::string getWtColor( nomDeLogiciel::Logiciel lg) const;
  
  void registerElement(nomdElements::typedElement nomdel,trivaluedBool b); 
  void setCompatiblesElements(); 

  nomDeLogiciel();  

 public : 
 
  nomDeLogiciel(const string& s);  
  nomDeLogiciel(int val);
  static int getNumberOfSoftwares();
  
  inline std::string getString() const {return progString_;}
  inline nomDeLogiciel::Logiciel getLogiciel() const {return program_;}


  inline const std::vector<nomdElements::typedElement>& acceptedElements() const { return acceptedElements_;
  }

  inline const std::vector<nomdElements::typedElement>& ignoredElements() const { return ignoredElements_;
  }

  trivaluedBool doAcceptElement(nomdElements::typedElement typdel) const; 


  /** Color of the background of the sofware
      Should be a valid Css name as FFEEDD
  */
  inline std::string  getColor() const {return getWtColor(program_);}
  // operators
  nomDeLogiciel& operator= (const nomDeLogiciel& nl);  
  bool operator== (const nomDeLogiciel& nl);  
  bool operator!= (const nomDeLogiciel& nl);
};
#endif
