#ifndef GWT_COMPUTINGBLOCK_SEEN
#define GWT_COMPUTINGBLOCK_SEEN

#include <Wt/WContainerWidget>
#include <Wt/WComboBox>
#include <Wt/WText>
#include <Wt/WSignal>

class GWt_softwarePanel;
class GWt_machine;
class computingBlock;

class GWt_computingBlock : public Wt::WContainerWidget
{
    public :
    GWt_computingBlock(Wt::WComboBox* ,Wt::WComboBox* ,Wt::WComboBox*,Wt::WContainerWidget* ,computingBlock*,GWt_machine* );

    ~GWt_computingBlock() {;}

    void setSoftware();
  void changeFirstElement();
  void changeLastElement();
  
    inline Wt::WString getFirstElementCurrentText() {
        return firstElement_->currentText();
    }
    
    inline Wt::WString getLastElementCurrentText() {
        return lastElement_->currentText();
    }
    
    inline Wt::WComboBox * getFirstElement() {
        return firstElement_;
    }
    
    inline Wt::WComboBox * getLastElement() {
        return lastElement_;
    }
    
    void setFirstElementCurrentSelection_deprecated(Wt::WString);
    void setLastElementCurrentSelection_deprecated(Wt::WString);
    void setSoftwareElementCurrentSelection_deprecated(Wt::WString);
    
    inline void setWarnings(Wt::WString warn){
        warningsLabel_->setText(warn);
        manageWarningsAndErrors();
    }

    inline void setErrors(Wt::WString err){
        errorsLabel_->setText(err);
        manageWarningsAndErrors();
    }

    Wt::Signal<void> redraw_;

    private :
    
    void manageWarningsAndErrors();
    Wt::WComboBox*  firstElement_;
    Wt::WComboBox*  lastElement_;
    Wt::WComboBox*  softElement_;
    computingBlock* cpblock_;
    GWt_machine* UImachine_;

    Wt::WText* errorsLabel_;
    Wt::WText* warningsLabel_;

    Wt::WContainerWidget* warningsContainer_;
    Wt::WContainerWidget* errorsContainer_;
};

#endif
