#ifndef GWt_PSPA_Application_SEEN
#define GWt_PSPA_Application_SEEN

#include <cstdlib>
#include <string.h>
#include <vector>

#include <Wt/WApplication>
#include <Wt/WEnvironment>
#include <Wt/WContainerWidget>
#include <Wt/WText>
#include <Wt/WLineEdit>
#include <Wt/WPanel>
#include <Wt/WComboBox>
#include <Wt/WPushButton>
#include <Wt/WButtonGroup>

#include "GWt_dialog.h"
#include "GWt_console.h"
//#include "GWt_softwarePanel.h"
#include "GWt_globalParameters.h"
#include "GWt_sectorParameters.h"

#include "dataManager.h"

class GWt_abstractElementFactory;
class GWt_ligneFaisceau;

using namespace Wt;

class PspaApplication : public WApplication
{
        
 private :
  
  dataManager* dtmanage_;
  string workingDir_;
  WDialog* dialogSave_;
  WDialog* dialogOpen_;
  WLineEdit* saveNameEdit_;
  WLineEdit* openNameEdit_;
    
  GWt_globalParameters* globalParam_;
  GWt_sectorParameters* sectorParam_;
  string nameOfCase_;

  WText* probleme_;

  WString applicationDefaultTitle_;
    
  WFileUpload* uploadFileSelectorWidget_;
  GWt_console* console_;
  GWt_abstractElementFactory* abstractElementFactory_;
  WContainerWidget* acceleratorContainerWidget_;
  
  WText* createTitle(const WString&);
  WWidget* createPalette(WContainerWidget* parent);
  WWidget* createBeamLine_deprecated();
  WWidget* createExecuteWidget();

  WWidget* createDashBoard(WContainerWidget*);
  
  void messageBox1();
  void messageBox2();
  
  // extensions (.001, .002,...) pour les fichiers "snapshot" 
  int extensionFile_;
  
  void createDragImage(const char *url,const char *smallurl,const char *mimeType,WContainerWidget *p,WString());
  void sauver();
  void dialogSaveDone(WDialog::DialogCode code);
  void restaurer();
  void chargerConfig();
  void openFileSelector();
  void fileTooLarge();
  
  bool removePathFromConfigName(string& config);
  bool removeExtensionFromConfigName(string& config, string extension);
  void createAccelerator();
  
 public :
  
  PspaApplication(const WEnvironment& env);
  
  string getSelection();
  void faireDessin();

  inline dataManager* getDataManager() const  {
    return dtmanage_;
  }
  
  inline GWt_globalParameters* getGlobalParam() const {
    return globalParam_; 
  }

  inline GWt_abstractElementFactory* getAbstractElementFactory() {
    return abstractElementFactory_;
  }

  inline string getWorkingDir() const {
    return workingDir_;
  }

  inline void setExtensionFile(int n) {
    extensionFile_ = n;
  }

  inline int getExtensionFile() const {
    return extensionFile_;
  }

};
#endif
